%define releasebase 1 
%define prefix /opt/gsl/%{version}
%define nbase gsl
#Use as deafults if no command line inputs
%define as_limulus 1
# NOTE: compilers are mutually exclusive, only set one,
#       if not using command line options
#       ! only GNU compilers are supported at this time
#       ! others can be added as needed
%define use_gnu4  1
%define use_gnu3 0
%define use_pgi  0
%define use_intel 0
%define use_pathsc 0
# allow --with[out] <feature> at rpm command line build
%{?_with_gnu3: %{expand: %%define use_gnu3 1}}
%{?_with_gnu4: %{expand: %%define use_gnu4 1}}
%{?_with_pgi: %{expand: %%define use_pgi 1}}
%{?_with_intel: %{expand: %%define use_intel 1}}
%{?_with_pathsc: %{expand: %%define use_pathsc 1}}
%{?_with_basement: %{expand: %%define as_basement 1}}
%{?_with_limulus: %{expand: %%define as_limulus 1}}
#pick the target
%if "1" == "%{as_basement}"
%define targetbase Basement
%else
%if "1" == "%{as_limulus}"
%define targetbase Limulus
%endif
%endif


Summary: The GNU Scientific Library
Version:  1.14
License: GPL
Group: %{targetbase}/Libraries
Release: %{releasebase}.%{targetbase}
URL: http://www.gnu.org/software/gsl
Packager: deadline@basement-supercomputing.com
Vendor: Basement Supercomputing.com
Source: %{nbase}-%{version}.tar.gz
Source1: gsl114/gsl-ref.html_node.tar.gz
Source2: gsl114/gsl-ref.ps.gz
Source3: gsl114/gsl-ref.txt.gz
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
Requires: modules
BuildRequires: modules

# is there a better way to do this?
%if "1" == "%{use_pgi}"
Name: %{nbase}-pgi
%define buildprefix %{prefix}/pgi
%define modprefix pgi
%define makeprefix  pgi
%else
%if "1" == "%{use_intel}"
Name: %{nbase}-intel
%define modprefix intel
%define buildprefix %{prefix}/intel
%define makeprefix intel
%else
%if "1" == "%{use_pathsc}"
Name: %{nbase}-pathsc
%define modprefix pathsc
%define buildprefix %{prefix}/pathsc
%else
%if "1" == "%{use_gnu4}"
Name: %{nbase}-gnu4
%define modprefix gnu4
%define makeprefix gnu4
%define buildprefix %{prefix}/gnu4
%else
%if "1" == "%{use_gnu3}"
Name: %{nbase}-gnu3
%define modprefix gnu3
%define makeprefix gnu
%define buildprefix %{prefix}/gnu3
%endif
%endif
%endif
%endif
%endif



%description
The GNU Scientific Library (GSL) is a numerical library for C and C++ programmers. 
It is free software under the GNU General Public License.
The library provides a wide range of mathematical routines such as random number 
generators, special functions and least-squares fitting. There are over 1000 functions 
in total with an extensive test suite.

The complete range of subject areas covered by the library includes,
Complex Numbers             Roots of Polynomials     Special Functions
Vectors and Matrices        Permutations             Sorting
BLAS Support                Linear Algebra           Eigensystems
Fast Fourier Transforms     Quadrature               Random Numbers
Quasi-Random Sequences      Random Distributions     Statistics
Histograms                  N-Tuples                 Monte Carlo Integration
Simulated Annealing         Differential Equations   Interpolation
Numerical Differentiation   Chebyshev Approximation  Series Acceleration
Discrete Hankel Transforms  Root-Finding             Minimization
Least-Squares Fitting       Physical Constants       IEEE Floating-Point
Discrete Wavelet Transforms 		



%prep
%setup -b 0 -T  -n %{nbase}-%{version}

%build
%if "1" == "%{use_pgi}"
       . /etc/profile.d/modules.sh
  	module load pgi62
%endif
./configure --prefix=%{buildprefix}

make 
# un-comment to run the check
#make check

%install
make  DESTDIR=%{buildroot} install

#Add the html, text, and PS manual for the docs
/bin/mkdir -p html
cd html
tar xvzf $RPM_SOURCE_DIR/gsl-ref.html_node.tar.gz
cd ..
/bin/cp $RPM_SOURCE_DIR/gsl-ref.ps.gz .
gunzip gsl-ref.ps.gz 
/bin/cp  $RPM_SOURCE_DIR/gsl-ref.txt.gz . 
gunzip  gsl-ref.txt.gz 
# include examples
cd doc
/bin/cp -r examples %{buildroot}/%{buildprefix}/share
cd ..
%post
/sbin/ldconfig 2>/dev/null
#create the module file
cat <<EOF >/opt/Modules/modulefiles/gsl-%{modprefix}
#%Module1.0#######################################################################
## GSL modulefile
##

proc ModulesHelp { } {
        puts stderr "\tThis module loads the appropriate environment for "
        puts stderr "\tusing gsl-%{modprefix} version %{version}.\n"
}

module-whatis "gsl-%{modprefix}-%{version}"
module-log error none

set gslroot /opt/gsl/%{version}/%{modprefix}

if [ module-info mode load ] {
	append-path MANPATH \$gslroot/man
	setenv GSL_PATH \$gslroot/lib
	setenv GSL_INCLUDE \$gslroot/include
}
if [ module-info mode remove ] {
	remove-path MANPATH \$gslroot/man
	unsetenv GSL_PATH 
	unsetenv GSL_INCLUDE 
}
EOF

%postun
/sbin/ldconfig 2>/dev/null
/bin/rm /opt/Modules/modulefiles/gsl-%{modprefix}

%clean
%{__rm} -rf %{buildroot}

%files
%defattr(-, root, root, 0755)
%doc COPYING TODO BUGS INSTALL README AUTHORS THANKS NEWS  gsl-ref.ps gsl-ref.txt html
%{buildprefix}/bin/*
%{buildprefix}/lib/*
%{buildprefix}/include/*
%{buildprefix}/share/*
%changelog
